package betterwithmods.common.blocks.tile.gen;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.mechanical.BlockWindmill;
import betterwithmods.util.DirUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

//TODO almost need to completely rewrite these in terms of capabilities.
public class TileEntityWindmillHorizontal extends TileAxleGenerator implements IColor {
    public int[] bladeMeta = {0, 0, 0, 0};

    public TileEntityWindmillHorizontal() {
        super();
        this.radius = 7;
    }

    @Override
    public int getMinimumInput(EnumFacing facing) {
        return 0;
    }

    public int getBladeColor(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public int getColorFromBlade(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public boolean dyeBlade(int dyeColor) {
        boolean dyed = false;
        if (bladeMeta[dyeIndex] != dyeColor) {
            bladeMeta[dyeIndex] = dyeColor;
            dyed = true;
            IBlockState state = func_145831_w().func_180495_p(this.field_174879_c);
            this.func_145831_w().func_184138_a(this.field_174879_c, state, state, 3);
            this.func_70296_d();
        }
        dyeIndex++;
        if (dyeIndex > 3)
            dyeIndex = 0;
        return dyed;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        for (int i = 0; i < 4; i++) {
            if (tag.func_74764_b("Color_" + i))
                bladeMeta[i] = tag.func_74762_e("Color_" + i);
        }
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        for (int i = 0; i < 4; i++) {
            t.func_74768_a("Color_" + i, bladeMeta[i]);
        }
        t.func_74774_a("DyeIndex", this.dyeIndex);
        return t;
    }

    @Override
    public void calculatePower() {
        byte power;
        if (isValid() && isOverworld() || isNether()) {

            if (field_145850_b.func_72896_J()) {
                power = 2;
            } else if (field_145850_b.func_72911_I()) {
                power = 3;
            } else {
                power = 1;
            }
        } else {
            power = 0;
        }
        if (power != this.power) {
            setPower(power);
        }
    }

    @Override
    public void verifyIntegrity() {
        boolean valid = true;
        if (func_145831_w().func_180495_p(field_174879_c).func_177230_c() != null && func_145831_w().func_180495_p(field_174879_c).func_177230_c() == BWMBlocks.WINDMILL) {
            EnumFacing.Axis axis = func_145831_w().func_180495_p(field_174879_c).func_177229_b(DirUtils.AXIS);
            for (int vert = -6; vert <= 6; vert++) {
                for (int i = -6; i <= 6; i++) {
                    int xP = (axis == EnumFacing.Axis.Z ? i : 0);
                    int zP = (axis == EnumFacing.Axis.X ? i : 0);
                    BlockPos offset = field_174879_c.func_177982_a(xP, vert, zP);
                    if (xP == 0 && vert == 0 && zP == 0)
                        continue;
                    else
                        valid = func_145831_w().func_175623_d(offset);
                    if (!valid)
                        break;
                }
                if (!valid)
                    break;
            }
        }
        isValid = valid && this.func_145831_w().func_175710_j(field_174879_c);
    }

    //Extend the bounding box if the TESR is bigger than the occupying block.
    @Override
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox() {
        int x = field_174879_c.func_177958_n();
        int y = field_174879_c.func_177956_o();
        int z = field_174879_c.func_177952_p();
        if (func_145831_w().func_180495_p(field_174879_c).func_177230_c() != null && func_145831_w().func_180495_p(field_174879_c).func_177230_c() instanceof BlockWindmill) {
            EnumFacing.Axis axis = func_145831_w().func_180495_p(field_174879_c).func_177229_b(DirUtils.AXIS);
            int xP = axis == EnumFacing.Axis.Z ? radius : 0;
            int yP = radius;
            int zP = axis == EnumFacing.Axis.X ? radius : 0;
            return new AxisAlignedBB(x - xP - 1, y - yP - 1, z - zP - 1, x + xP + 1, y + yP + 1, z + zP + 1);
        } else {
            return super.getRenderBoundingBox();
        }
    }
}
