package betterwithmods.common.blocks.tile.gen;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.mechanical.BlockWindmill;
import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

//TODO almost need to completely rewrite these in terms of capabilities.
public class TileEntityWindmillVertical extends TileAxleGenerator implements IColor {
    public int[] bladeMeta = {0, 0, 0, 0, 0, 0, 0, 0};

    public int getBladeColor(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public int getMinimumInput(EnumFacing facing) {
        return 0;
    }

    @Override
    public int getColorFromBlade(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public boolean dyeBlade(int dyeColor) {
        boolean dyed = false;
        if (bladeMeta[dyeIndex] != dyeColor) {
            bladeMeta[dyeIndex] = dyeColor;
            dyed = true;
            IBlockState state = func_145831_w().func_180495_p(this.field_174879_c);
            this.func_145831_w().func_184138_a(this.field_174879_c, state, state, 3);
            this.func_70296_d();
        }
        dyeIndex++;
        if (dyeIndex > 7)
            dyeIndex = 0;
        return dyed;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        for (int i = 0; i < 8; i++) {
            if (tag.func_74764_b("Color_" + i))
                bladeMeta[i] = tag.func_74762_e("Color_" + i);
        }
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        for (int i = 0; i < 8; i++) {
            t.func_74768_a("Color_" + i, bladeMeta[i]);
        }
        t.func_74774_a("DyeIndex", this.dyeIndex);
        return t;
    }

    public boolean isSlaveValid(int offset) {
        int airCounter = 0;
        for (int x = -4; x <= 4; x++) {
            for (int z = -4; z <= 4; z++) {
                BlockPos offPos = field_174879_c.func_177982_a(x, offset, z);
                if (x == 0 && z == 0)
                    continue;
                if (func_145831_w().func_175623_d(offPos)) {
                    airCounter++;
                } else {
                    return false;
                }

            }
        }
        return airCounter > 25;
    }

    @Override
    public void verifyIntegrity() {
        boolean valid = false;
        if (func_145831_w().func_180495_p(field_174879_c).func_177230_c() == BWMBlocks.WINDMILL) {
            for (int i = -3; i <= 3; i++) {
                if (i != 0) {
                    if (isSlaveValid(i)) {
                        valid = true;
                    } else {
                        valid = false;
                        break;
                    }
                }
            }
        }

        isValid = valid && this.func_145831_w().func_175710_j(field_174879_c);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void onDataPacket(NetworkManager mgr, SPacketUpdateTileEntity pkt) {
        NBTTagCompound tag = pkt.func_148857_g();
        this.func_145839_a(tag);
        IBlockState state = func_145831_w().func_180495_p(this.field_174879_c);
        this.func_145831_w().func_184138_a(this.field_174879_c, state, state, 3);
    }

    @Override
    public NBTTagCompound func_189517_E_() {
        return func_189515_b(new NBTTagCompound());
    }

    @Override
    public void calculatePower() {
        byte power;
        if (isValid() && (isOverworld() || isNether())) {
            if (field_145850_b.func_72896_J()) {
                power = 2;
            } else if (field_145850_b.func_72911_I()) {
                power = 3;
            } else {
                power = 1;
            }
        } else {
            power = 0;
        }
        if (power != this.power) {
            setPower(power);
        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox() {
        int x = field_174879_c.func_177958_n();
        int y = field_174879_c.func_177956_o();
        int z = field_174879_c.func_177952_p();
        if (func_145831_w().func_180495_p(field_174879_c).func_177230_c() != null && func_145831_w().func_180495_p(field_174879_c).func_177230_c() instanceof BlockWindmill)
            return new AxisAlignedBB(x - 4, y - 4, z - 4, x + 4, y + 4, z + 4);
        else
            return super.getRenderBoundingBox();
    }
}
